package edu.fu_tdg.lodib.mapping.sparql;

import java.io.File;

import com.hp.hpl.jena.query.Dataset;
import com.hp.hpl.jena.sparql.core.DatasetGraph;
import edu.fu_tdg.lodib.mapping.DataTranslationException;
import edu.fu_tdg.lodib.mapping.DataTranslationMapping;
import edu.fu_tdg.lodib.mapping.InputDataTranslationMapping;
import edu.fu_tdg.lodib.utils.Utils;

public abstract class SPARQLMapping implements DataTranslationMapping {
	protected String query;
	protected String namespaces;
	
	public SPARQLMapping(InputDataTranslationMapping input) {
		super();
		StringBuffer buf = new StringBuffer();
		for (String prefix : input.getNamespaces().keySet()) {
			buf.append(Utils.PREFIX);
			buf.append(Utils.SPACE);
			buf.append(prefix);
			buf.append(Utils.SPACE);
			buf.append(Utils.toURI(input.getNamespaces().get(prefix), null));
			buf.append(Utils.SPACE);
			
		}
		namespaces = buf.toString();
	}

	public final void execute(File in, File out) throws DataTranslationException {
		Utils.executeJenaQuery(in, out, namespaces + query);
	}

    public final void execute(Dataset in, File out) throws DataTranslationException {
        Utils.executeJenaQuery(in, out, namespaces + query);
    }
}
