package edu.fu_tdg.lodib.mapping.sparql.factory.jena;

import edu.fu_tdg.lodib.mapping.InputDataTranslationMapping;
import edu.fu_tdg.lodib.mapping.sparql.SPARQLMapping;
import edu.fu_tdg.lodib.utils.Utils;

public class DeresourcifyMappingJena extends SPARQLMapping {

	public DeresourcifyMappingJena(InputDataTranslationMapping input) {
		super(input);
		// New variables
		String varX = "?x", varY = "?y", varZ = "?z";
		
		// Create source and target triples
		String sourceTriple1 = Utils.buildPropertyTriplePattern(varX, input.getSourceProperty1(), varZ);
		String sourceTriple2 = Utils.buildPropertyTriplePattern(varZ, input.getSourceProperty2(), varY);
		String targetTriple = Utils.buildPropertyTriplePattern(varX, input.getTargetProperty(), varY);
		
		
		// Build SPARQL Construct
		query = Utils.buildSPARQLConstruct(sourceTriple1 + Utils.SPACE + sourceTriple2, targetTriple);
	}

}
