package edu.fu_tdg.lodib.mapping.sparql.factory.jena;

import java.util.ArrayList;
import java.util.List;

import edu.fu_tdg.lodib.mapping.InputDataTranslationMapping;
import edu.fu_tdg.lodib.mapping.sparql.SPARQLMapping;
import edu.fu_tdg.lodib.utils.Utils;

public class NToOneMappingJena extends SPARQLMapping {

	public NToOneMappingJena(InputDataTranslationMapping input) {
		super(input);
		// New variables
		String varX = "?x", varY = "?y", varZ = "?z";
		
		// Create source and target triples
		StringBuffer buf = new StringBuffer();
		List<String> yVars = new ArrayList<String>();
		int i = 0;
		for (String srcProp : input.getNSourceProperties()) {
			String newYVar = varY + i;
			yVars.add(newYVar);
			buf.append(Utils.buildPropertyTriplePattern(varX, srcProp, newYVar));
			i++;
		}
		buf.append(Utils.buildAssignment(varZ, Utils.buildFunction(yVars, input.getFunction())));
		String targetTriple = Utils.buildPropertyTriplePattern(varX, input.getTargetProperty(), varZ);
		
		// Build SPARQL Construct
		query = Utils.buildSPARQLConstruct(buf.toString(), targetTriple);
	}

}
