package edu.fu_tdg.lodib.mapping.sparql.factory.jena;

import edu.fu_tdg.lodib.mapping.InputDataTranslationMapping;
import edu.fu_tdg.lodib.mapping.sparql.SPARQLMapping;
import edu.fu_tdg.lodib.mapping.sparql.factory.jena.function.RemoveLangTag;
import edu.fu_tdg.lodib.utils.Utils;

public class RemoveLangTagMappingJena extends SPARQLMapping {

	public RemoveLangTagMappingJena(InputDataTranslationMapping input) {
		super(input);
		// New variables
		String varX = "?x", varY = "?y", varZ = "?z";
		
		// Create source and target triples
		String sourceTriple1 = Utils.buildPropertyTriplePattern(varX, input.getSourceProperty(), varY);
		String sourceTriple2 = Utils.buildAssignment(varZ, Utils.buildFunction(varY, RemoveLangTag.URI));
		String targetTriple = Utils.buildPropertyTriplePattern(varX, input.getTargetProperty(), varZ);
		
		// Build SPARQL Construct
		query = Utils.buildSPARQLConstruct(sourceTriple1 + sourceTriple2, targetTriple);
	}

}
