package edu.fu_tdg.lodib.mapping.sparql.factory.jena;

import edu.fu_tdg.lodib.mapping.InputDataTranslationMapping;
import edu.fu_tdg.lodib.mapping.sparql.SPARQLMapping;
import edu.fu_tdg.lodib.mapping.sparql.factory.jena.function.StringToURI;
import edu.fu_tdg.lodib.utils.Utils;

public class ValueToURIMappingJena extends SPARQLMapping {

	public ValueToURIMappingJena(InputDataTranslationMapping input) {
		super(input);
		// New variables
		String varX = "?x", varY = "?y", varZ = "?z";
		
		// Create source and target triples
		String sourceTriple1 = Utils.buildPropertyTriplePattern(varX, input.getSourceProperty(), varY);
		String sourceTriple2 = Utils.buildPropertyTriplePattern(varY, Utils.toURI(StringToURI.URI, null), varZ);
		String targetTriple = Utils.buildPropertyTriplePattern(varX, input.getTargetProperty(), varZ);
		
		// Build SPARQL Construct
		query = Utils.buildSPARQLConstruct(sourceTriple1 + sourceTriple2, targetTriple);
	}

}
