package edu.fu_tdg.lodib.rdf_generator.distributions;

import tdg.random.backbone.Backbone;
import tdg.random.backbone.EcuyerBackbone;
import tdg.random.continuous.Uniform;
import tdg.random.core.Random;
import tdg.random.seedbed.EcuyerSeedbed;
import tdg.random.seedbed.Seedbed;

public class UniformDistribution<T> implements Distribution<T> {
	private Random rnd;
    private java.util.Random seedGen = new java.util.Random(202020L);
	private T a;
	
	public UniformDistribution(T a, T b) {
		this.a = a;
		Seedbed sb = EcuyerSeedbed.getInstance();
		Backbone bck = new EcuyerBackbone(sb.getSeed(seedGen.nextInt(500)));
		
		if (a instanceof Integer)
			rnd = new Uniform(bck, (Integer) a, (Integer) b);
		else if (a instanceof Long)
			rnd = new Uniform(bck, (Long) a, (Long) b);
		else if (a instanceof Float)
			rnd = new Uniform(bck, (Float) a, (Float) b);
		else if (a instanceof Double)
			rnd = new Uniform(bck, (Double) a, (Double) b);
		
		;
	}
	
	public T getValue() {
		T ret = null;
		if (a instanceof Integer)
			ret = (T) Integer.valueOf(rnd.intValue());
		else if (a instanceof Long)
			ret = (T) Long.valueOf(rnd.longValue());
		else if (a instanceof Float)
			ret = (T) Float.valueOf(rnd.floatValue());
		else if (a instanceof Double)
			ret = (T) Double.valueOf(rnd.doubleValue());
		return ret;
	}

	public void advanceValue() {
		rnd.advance();
	}

}
