package edu.fu_tdg.lodib.test;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Collection;
import java.util.Set;

import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.ontology.OntModelSpec;
import com.hp.hpl.jena.query.Query;
import com.hp.hpl.jena.query.QueryExecutionFactory;
import com.hp.hpl.jena.query.Syntax;
import com.hp.hpl.jena.rdf.model.ModelFactory;

import edu.fu_tdg.lodib.rdf_generator.RDFGeneratorException;
import edu.fu_tdg.lodib.utils.Utils;
import edu.fu_tdg.lodib.validator.DataLoader;

public class MappingTest {

	/**
	 * @param args
	 * @throws RDFGeneratorException 
	 */
	public static void main(String[] args) throws Exception {
//		if (args.length == 3) {
			String sourceFile = "source1.nt";
			String targetFile = "target1.nt";
			String queriesFile = "mappings/src1-tgt-mosto.qry";
			
			OntModel source = ModelFactory.createOntologyModel(OntModelSpec.OWL_MEM, DataLoader.createTmpTDBModel());
			source.read(new FileInputStream(new File(sourceFile)), "", Utils.N_TRIPLE);
			
			OntModel target = ModelFactory.createOntologyModel(OntModelSpec.OWL_MEM, DataLoader.createTmpTDBModel());
			
			Set<Query> queries = Utils.parseJenaSPARQLQueries(queriesFile, Syntax.syntaxARQ);
			
			performDataTranslation(source, target, queries);
			
			target.write(new FileOutputStream(new File(targetFile)), Utils.N_TRIPLE);
//		} else {
//			System.out.println("Parameters: <source file> <target file> <queries file>");
//			System.exit(1);
//		}
	}
	
	public static void performDataTranslation(OntModel source, OntModel target, Collection<Query> mappings) {
		for (Query m : mappings)
			QueryExecutionFactory.create(m, source).execConstruct(target);
	}

}
