package edu.fu_tdg.lodib.validator

import com.hp.hpl.jena.tdb.store.DatasetGraphTDB
import java.io.File
import com.hp.hpl.jena.query.{Dataset, QueryExecutionFactory}
import com.hp.hpl.jena.rdf.model.Model
import com.hp.hpl.jena.tdb.{TDBLoader, TDBFactory}

/**
 * Created by IntelliJ IDEA.
 * User: andreas
 * Date: 1/19/12
 * Time: 4:44 PM
 * To change this template use File | Settings | File Templates.
 */

object DataLoader {
  def loadDataset(file: String): Dataset = {
    val tdbloader = new TDBLoader
    tdbloader.setGenerateStats(true)
    val tempName = getTempFileName()
    val datasetGraph = TDBFactory.createDatasetGraph(tempName)
    tdbloader.loadDataset(datasetGraph, file)
    datasetGraph.finishRequest()
    return datasetGraph.toDataset
  }

  def openDataset(datasetDir: String): Dataset = {
    TDBFactory.createDatasetGraph(datasetDir).toDataset
  }

  def createTmpTDBModel(): Model = {
    val tempName = getTempFileName()
    return TDBFactory.createModel(tempName)
  }

  private def getTempFileName(): String = {
    val tempFile = File.createTempFile("lodib", "db")
    val tempName = tempFile.getAbsolutePath
    tempFile.delete()
    return tempName
  }
}